/* Software License Agreement (BSD License)
 *
 * Copyright (c) 2011, Willow Garage, Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above
 *    copyright notice, this list of conditions and the following
 *    disclaimer in the documentation and/or other materials provided
 *    with the distribution.
 *  * Neither the name of Willow Garage, Inc. nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 * COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 * ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 *
 * Auto-generated by genmsg_cpp from file /local/robotpkg/var/tmp/robotpkg/sysutils/arduio-genom3/work/templates/ros/client/ros/arduio/msg/arduio_state_s.msg
 *
 */


#ifndef ARDUIO_MESSAGE_ARDUIO_STATE_S_H
#define ARDUIO_MESSAGE_ARDUIO_STATE_S_H


#include <string>
#include <vector>
#include <map>

#include <ros/types.h>
#include <ros/serialization.h>
#include <ros/builtin_message_traits.h>
#include <ros/message_operations.h>

#include <arduio/arduio_dir_s.h>

namespace arduio
{
template <class ContainerAllocator>
struct arduio_state_s_
{
  typedef arduio_state_s_<ContainerAllocator> Type;

  arduio_state_s_()
    : diodir()
    , digital()
    , analog()  {
    }
  arduio_state_s_(const ContainerAllocator& _alloc)
    : diodir(_alloc)
    , digital(_alloc)
    , analog(_alloc)  {
    }



   typedef std::vector< ::arduio::arduio_dir_s_<ContainerAllocator> , typename ContainerAllocator::template rebind< ::arduio::arduio_dir_s_<ContainerAllocator> >::other >  _diodir_type;
  _diodir_type diodir;

   typedef std::vector<float, typename ContainerAllocator::template rebind<float>::other >  _digital_type;
  _digital_type digital;

   typedef std::vector<float, typename ContainerAllocator::template rebind<float>::other >  _analog_type;
  _analog_type analog;




  typedef boost::shared_ptr< ::arduio::arduio_state_s_<ContainerAllocator> > Ptr;
  typedef boost::shared_ptr< ::arduio::arduio_state_s_<ContainerAllocator> const> ConstPtr;

}; // struct arduio_state_s_

typedef ::arduio::arduio_state_s_<std::allocator<void> > arduio_state_s;

typedef boost::shared_ptr< ::arduio::arduio_state_s > arduio_state_sPtr;
typedef boost::shared_ptr< ::arduio::arduio_state_s const> arduio_state_sConstPtr;

// constants requiring out of line definition



template<typename ContainerAllocator>
std::ostream& operator<<(std::ostream& s, const ::arduio::arduio_state_s_<ContainerAllocator> & v)
{
ros::message_operations::Printer< ::arduio::arduio_state_s_<ContainerAllocator> >::stream(s, "", v);
return s;
}

} // namespace arduio

namespace ros
{
namespace message_traits
{



// BOOLTRAITS {'IsFixedSize': False, 'IsMessage': True, 'HasHeader': False}
// {'arduio': ['arduio/msg'], 'std_msgs': ['/opt/openrobots/share/std_msgs/msg'], 'actionlib_msgs': ['/opt/openrobots/share/actionlib_msgs/msg']}

// !!!!!!!!!!! ['__class__', '__delattr__', '__dict__', '__doc__', '__eq__', '__format__', '__getattribute__', '__hash__', '__init__', '__module__', '__ne__', '__new__', '__reduce__', '__reduce_ex__', '__repr__', '__setattr__', '__sizeof__', '__str__', '__subclasshook__', '__weakref__', '_parsed_fields', 'constants', 'fields', 'full_name', 'has_header', 'header_present', 'names', 'package', 'parsed_fields', 'short_name', 'text', 'types']




template <class ContainerAllocator>
struct IsFixedSize< ::arduio::arduio_state_s_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct IsFixedSize< ::arduio::arduio_state_s_<ContainerAllocator> const>
  : FalseType
  { };

template <class ContainerAllocator>
struct IsMessage< ::arduio::arduio_state_s_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::arduio::arduio_state_s_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct HasHeader< ::arduio::arduio_state_s_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct HasHeader< ::arduio::arduio_state_s_<ContainerAllocator> const>
  : FalseType
  { };


template<class ContainerAllocator>
struct MD5Sum< ::arduio::arduio_state_s_<ContainerAllocator> >
{
  static const char* value()
  {
    return "e711d16307d451403390b51c7a149e8b";
  }

  static const char* value(const ::arduio::arduio_state_s_<ContainerAllocator>&) { return value(); }
  static const uint64_t static_value1 = 0xe711d16307d45140ULL;
  static const uint64_t static_value2 = 0x3390b51c7a149e8bULL;
};

template<class ContainerAllocator>
struct DataType< ::arduio::arduio_state_s_<ContainerAllocator> >
{
  static const char* value()
  {
    return "arduio/arduio_state_s";
  }

  static const char* value(const ::arduio::arduio_state_s_<ContainerAllocator>&) { return value(); }
};

template<class ContainerAllocator>
struct Definition< ::arduio::arduio_state_s_<ContainerAllocator> >
{
  static const char* value()
  {
    return "# IDL struct ::arduio::state_s\n\
arduio_dir_s[] diodir\n\
float32[] digital\n\
float32[] analog\n\
\n\
================================================================================\n\
MSG: arduio/arduio_dir_s\n\
# IDL enum ::arduio::dir_s\n\
uint32 arduio_IO_IN = 0\n\
uint32 arduio_IO_IN_PU = 1\n\
uint32 arduio_IO_OUT = 2\n\
uint32 arduio_IO_PWM = 3\n\
\n\
uint32 value\n\
";
  }

  static const char* value(const ::arduio::arduio_state_s_<ContainerAllocator>&) { return value(); }
};

} // namespace message_traits
} // namespace ros

namespace ros
{
namespace serialization
{

  template<class ContainerAllocator> struct Serializer< ::arduio::arduio_state_s_<ContainerAllocator> >
  {
    template<typename Stream, typename T> inline static void allInOne(Stream& stream, T m)
    {
      stream.next(m.diodir);
      stream.next(m.digital);
      stream.next(m.analog);
    }

    ROS_DECLARE_ALLINONE_SERIALIZER;
  }; // struct arduio_state_s_

} // namespace serialization
} // namespace ros

namespace ros
{
namespace message_operations
{

template<class ContainerAllocator>
struct Printer< ::arduio::arduio_state_s_<ContainerAllocator> >
{
  template<typename Stream> static void stream(Stream& s, const std::string& indent, const ::arduio::arduio_state_s_<ContainerAllocator>& v)
  {
    s << indent << "diodir[]" << std::endl;
    for (size_t i = 0; i < v.diodir.size(); ++i)
    {
      s << indent << "  diodir[" << i << "]: ";
      s << std::endl;
      s << indent;
      Printer< ::arduio::arduio_dir_s_<ContainerAllocator> >::stream(s, indent + "    ", v.diodir[i]);
    }
    s << indent << "digital[]" << std::endl;
    for (size_t i = 0; i < v.digital.size(); ++i)
    {
      s << indent << "  digital[" << i << "]: ";
      Printer<float>::stream(s, indent + "  ", v.digital[i]);
    }
    s << indent << "analog[]" << std::endl;
    for (size_t i = 0; i < v.analog.size(); ++i)
    {
      s << indent << "  analog[" << i << "]: ";
      Printer<float>::stream(s, indent + "  ", v.analog[i]);
    }
  }
};

} // namespace message_operations
} // namespace ros

#endif // ARDUIO_MESSAGE_ARDUIO_STATE_S_H
