/* Software License Agreement (BSD License)
 *
 * Copyright (c) 2011, Willow Garage, Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above
 *    copyright notice, this list of conditions and the following
 *    disclaimer in the documentation and/or other materials provided
 *    with the distribution.
 *  * Neither the name of Willow Garage, Inc. nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 * COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 * ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 *
 * Auto-generated by genmsg_cpp from file /local/robotpkg/var/tmp/robotpkg/sysutils/arduio-genom3/work/templates/ros/client/ros/arduio/msg/genom_state_task.msg
 *
 */


#ifndef ARDUIO_MESSAGE_GENOM_STATE_TASK_H
#define ARDUIO_MESSAGE_GENOM_STATE_TASK_H


#include <string>
#include <vector>
#include <map>

#include <ros/types.h>
#include <ros/serialization.h>
#include <ros/builtin_message_traits.h>
#include <ros/message_operations.h>

#include <arduio/genom_state_rusage.h>
#include <arduio/genom_state_activity.h>

namespace arduio
{
template <class ContainerAllocator>
struct genom_state_task_
{
  typedef genom_state_task_<ContainerAllocator> Type;

  genom_state_task_()
    : name()
    , rusage()
    , activity()  {
    }
  genom_state_task_(const ContainerAllocator& _alloc)
    : name(_alloc)
    , rusage(_alloc)
    , activity(_alloc)  {
    }



   typedef std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other >  _name_type;
  _name_type name;

   typedef  ::arduio::genom_state_rusage_<ContainerAllocator>  _rusage_type;
  _rusage_type rusage;

   typedef std::vector< ::arduio::genom_state_activity_<ContainerAllocator> , typename ContainerAllocator::template rebind< ::arduio::genom_state_activity_<ContainerAllocator> >::other >  _activity_type;
  _activity_type activity;




  typedef boost::shared_ptr< ::arduio::genom_state_task_<ContainerAllocator> > Ptr;
  typedef boost::shared_ptr< ::arduio::genom_state_task_<ContainerAllocator> const> ConstPtr;

}; // struct genom_state_task_

typedef ::arduio::genom_state_task_<std::allocator<void> > genom_state_task;

typedef boost::shared_ptr< ::arduio::genom_state_task > genom_state_taskPtr;
typedef boost::shared_ptr< ::arduio::genom_state_task const> genom_state_taskConstPtr;

// constants requiring out of line definition



template<typename ContainerAllocator>
std::ostream& operator<<(std::ostream& s, const ::arduio::genom_state_task_<ContainerAllocator> & v)
{
ros::message_operations::Printer< ::arduio::genom_state_task_<ContainerAllocator> >::stream(s, "", v);
return s;
}

} // namespace arduio

namespace ros
{
namespace message_traits
{



// BOOLTRAITS {'IsFixedSize': False, 'IsMessage': True, 'HasHeader': False}
// {'arduio': ['arduio/msg'], 'std_msgs': ['/opt/openrobots/share/std_msgs/msg'], 'actionlib_msgs': ['/opt/openrobots/share/actionlib_msgs/msg']}

// !!!!!!!!!!! ['__class__', '__delattr__', '__dict__', '__doc__', '__eq__', '__format__', '__getattribute__', '__hash__', '__init__', '__module__', '__ne__', '__new__', '__reduce__', '__reduce_ex__', '__repr__', '__setattr__', '__sizeof__', '__str__', '__subclasshook__', '__weakref__', '_parsed_fields', 'constants', 'fields', 'full_name', 'has_header', 'header_present', 'names', 'package', 'parsed_fields', 'short_name', 'text', 'types']




template <class ContainerAllocator>
struct IsFixedSize< ::arduio::genom_state_task_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct IsFixedSize< ::arduio::genom_state_task_<ContainerAllocator> const>
  : FalseType
  { };

template <class ContainerAllocator>
struct IsMessage< ::arduio::genom_state_task_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::arduio::genom_state_task_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct HasHeader< ::arduio::genom_state_task_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct HasHeader< ::arduio::genom_state_task_<ContainerAllocator> const>
  : FalseType
  { };


template<class ContainerAllocator>
struct MD5Sum< ::arduio::genom_state_task_<ContainerAllocator> >
{
  static const char* value()
  {
    return "b6ebe21c3b706530495c8ef9b94c0cf3";
  }

  static const char* value(const ::arduio::genom_state_task_<ContainerAllocator>&) { return value(); }
  static const uint64_t static_value1 = 0xb6ebe21c3b706530ULL;
  static const uint64_t static_value2 = 0x495c8ef9b94c0cf3ULL;
};

template<class ContainerAllocator>
struct DataType< ::arduio::genom_state_task_<ContainerAllocator> >
{
  static const char* value()
  {
    return "arduio/genom_state_task";
  }

  static const char* value(const ::arduio::genom_state_task_<ContainerAllocator>&) { return value(); }
};

template<class ContainerAllocator>
struct Definition< ::arduio::genom_state_task_<ContainerAllocator> >
{
  static const char* value()
  {
    return "# IDL struct ::genom::state::task\n\
string name\n\
genom_state_rusage rusage\n\
genom_state_activity[] activity\n\
\n\
================================================================================\n\
MSG: arduio/genom_state_rusage\n\
# IDL struct ::genom::state::rusage\n\
uint32 cycles\n\
genom_state_stats timings\n\
genom_state_stats load\n\
\n\
================================================================================\n\
MSG: arduio/genom_state_stats\n\
# IDL struct ::genom::state::stats\n\
float32 last\n\
float32 max\n\
float32 avg\n\
\n\
================================================================================\n\
MSG: arduio/genom_state_activity\n\
# IDL struct ::genom::state::activity\n\
uint32 id\n\
string name\n\
";
  }

  static const char* value(const ::arduio::genom_state_task_<ContainerAllocator>&) { return value(); }
};

} // namespace message_traits
} // namespace ros

namespace ros
{
namespace serialization
{

  template<class ContainerAllocator> struct Serializer< ::arduio::genom_state_task_<ContainerAllocator> >
  {
    template<typename Stream, typename T> inline static void allInOne(Stream& stream, T m)
    {
      stream.next(m.name);
      stream.next(m.rusage);
      stream.next(m.activity);
    }

    ROS_DECLARE_ALLINONE_SERIALIZER;
  }; // struct genom_state_task_

} // namespace serialization
} // namespace ros

namespace ros
{
namespace message_operations
{

template<class ContainerAllocator>
struct Printer< ::arduio::genom_state_task_<ContainerAllocator> >
{
  template<typename Stream> static void stream(Stream& s, const std::string& indent, const ::arduio::genom_state_task_<ContainerAllocator>& v)
  {
    s << indent << "name: ";
    Printer<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other > >::stream(s, indent + "  ", v.name);
    s << indent << "rusage: ";
    s << std::endl;
    Printer< ::arduio::genom_state_rusage_<ContainerAllocator> >::stream(s, indent + "  ", v.rusage);
    s << indent << "activity[]" << std::endl;
    for (size_t i = 0; i < v.activity.size(); ++i)
    {
      s << indent << "  activity[" << i << "]: ";
      s << std::endl;
      s << indent;
      Printer< ::arduio::genom_state_activity_<ContainerAllocator> >::stream(s, indent + "    ", v.activity[i]);
    }
  }
};

} // namespace message_operations
} // namespace ros

#endif // ARDUIO_MESSAGE_GENOM_STATE_TASK_H
